/*****************************
* Source : npipes.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 18/12/2002             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    18/12/2002 12:54 PPI - Created                
*****************************/
                              
#include "dll.ch"
#include "Common.ch"
#include "pipes.ch"

DLLFUNCTION CreateFileA(@lpPipeName,dwAccess,dwShareMode,@lpSecurity,dwCreate,dwFlags,nTemplate) USING OSAPI FROM Kernel32.dll

CLASS NamedPipeClient FROM NamedPipeBase
   PROTECTED:
      METHOD connect

   EXPORTED:
      METHOD init

ENDCLASS

METHOD NamedPipeClient:init(cPipe)
   ::namedPipeBase:init()
   ::cPipeName := cPipe
   ::connect(cPipe)
   return (self)

METHOD NamedPipeClient:connect()
   local nHnd
   local cPipe := ::cPipeName
   local pSecurity     := CreateWin32APISecurityStructureForPipes()

   if !(::nHnd > 0)
      nHnd := CreateFileA(@cPipe,;
                         GENERIC_READ+GENERIC_WRITE,;
                         0,;
                         @pSecurity,;
                         OPEN_EXISTING,;
                         0,;
                         0)
      if nHnd > 0
         ::nHnd := nHnd
      endif
   endif
   return ::nHnd



