/*****************************
* Source : pipeutils.prg
* System : <unkown>           
* Author : Phil Ide           
* Created: 18/12/2002             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    18/12/2002 12:50 PPI - Created                
*****************************/

#include "common.ch"
#include "bap.ch"

#pragma Library("bap.lib")

#define NAME_SEQUENCE 20021219

Function CreateWin32APISecurityStructureForPipes()
   local aSecurity
   aSecurity := BAInit(3)
   BaStruct(aSecurity,0)
   BaStruct(aSecurity,0)
   BaStruct(aSecurity,TRUE)
   Return BaAccess(aSecurity)

Function CreateUniquePipeName(nID)
   local cPipe

   default nID to NAME_SEQUENCE

   cPipe := 'Xbpp.dbfServer.'+Hex(NAME_SEQUENCE,4)

   return '\\.\pipe\'+cPipe


STATIC function hex( n, i )
   local c := '0123456789ABCDEF'
   local x
   local cHex := ''

   while n > 0
      x := n%16
      cHex := substr( c, x+1, 1 ) + cHex
      n := int(n/16)
   enddo
   if valtype(i) == 'N' .and. i > len(cHex)
      cHex := padl( cHex, i, '0' )
   endif

   return (cHex)

