/*****************************
* Source : NamedPipeServerTest.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 27/12/2002             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    27/12/2002 11:22 PPI - Created                
*****************************/
                              
#include "Common.ch"
#include "Appevent.ch"
#include "inkey.ch"
#include "pipes.ch"

Function Main(p1)
   local oXbp
   local mp1
   local mp2
   local nEvent := 0
   local cBuff
   local oServer := NamedPipeServer():new()
   local nRow
   local nMsg := 0
   local lQuiet

   SetCursor(0)

   default p1 to 'n'

   lQuiet := (upper(p1) == 'Q')

   ? 'Usage: NpServer [q]'
   ? ' q = enable QUIET mode for faster throughput'
   ?
   oServer:createPipe()
   ? 'Listening on pipe: '+oServer:remotePipeName()
   ?
   nRow := Row()
   oServer:acceptConnection()

   while inkey() <> K_ESC
      cBuff := oServer:recv()
      if !lQuiet
         @ nRow, 0 say 'Receiving Message #'+LTrim(Str(++nMsg))
      endif
      if (ValType(cBuff) == 'C') .and. (cBuff == 'CLOSE_PIPE')
         oServer:disconnect()
         exit
      endif
   enddo
   SetCursor(1)
   return NIL

