/*****************************
* Source : namedpipeclienttest.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 27/12/2002             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    27/12/2002 12:01 PPI - Created                
*****************************/
                              
#include "Common.ch"
#include "Appevent.ch"
#include "inkey.ch"
#include "pipes.ch"

#define BUFF_MAG  16
#define BUFF_SIZE 1024
#define BUFF_PAGE BUFF_SIZE*BUFF_MAG
#define MEGABYTE  (1024*1024)

Function Main(cServer)
   local oXbp
   local mp1
   local mp2
   local nEvent := 0
   local cBuff
   local cPipeName
   local oClient
   local cdata
   local nSecs
   local i
   local nRow
   local lQuiet

   default cServer to '.'

   cPipeName := '\\'+cServer+'\pipe\'+substr(CreateUniquePipeName(),10)
   oClient := NamedPipeClient():new(cPipeName)

   ? 'Connecting to pipe: '+cPipeName

   cData := Replicate(Replicate('o',BUFF_SIZE), BUFF_MAG)
   cData := '['+left(cdata,len(cdata)-6)+']'+Chr(13)+Chr(10)+Chr(13)+Chr(10)

   ? 'Press any key to start'
   ? 'press Q for quiet mode -  quiet mode has faster throughput'
   ?
   nRow := Row()
   lQuiet := Upper(Chr(inkey(0))) == 'Q'
   nSecs := Seconds()+10
   i := 0
   while Seconds() < nSecs
      i++
      if !lQuiet
         @ nRow, 0 say 'Sending message #'+LTrim(Str(i))
      endif
      oClient:write(cData)
   enddo

   oClient:write('CLOSE_PIPE')
   oClient:disconnect()
   ? 'Throughput: ', LTrim(Str((((BUFF_PAGE*i)/MEGABYTE))/10))+'Mb/second sustained over 10 seconds'
   ? 'Total transmission size: '+LTrim(Str((BUFF_PAGE*i)/MEGABYTE))+'Mb'
   return NIL

