/*****************************
* Source : PipeTest.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 07/12/2002             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    07/12/2002 22:02 PPI - Created                
*****************************/
                              
#include "Common.ch"
#include "dll.ch"

DLLFUNCTION WinExec( cCmd, nWinMode ) USING OSAPI FROM Kernel32.DLL

#define BUFF_SIZE 1024*1

Procedure Main()
   local cBuffer := space(1)
   local oPipe := UnNamedPipe():new()
   local cCmdLne := oPipe:pipeIn(TRUE)+' '+oPipe:pipeOut(TRUE)
   local nCount := 0
   local oThread := Thread():new()
   local cBuff := Replicate('A',BUFF_SIZE)
   local nSecs
   local nTSecs
   local i := 0
   local nSize
   local nTime

   if !oPipe:error(TRUE)
      ? 'Preparing sub-process'
      ? 'Sending data'
      nSecs := Seconds()+10
      oThread:start("Thread2",oPipe)
      while Seconds() < nSecs
         oPipe:write(cBuff)
         i++
      enddo
      oPipe:write('CLOSE_PIPE')
      oPipe:closeIn()
      nSize := (i*BUFF_SIZE) / (1024*1024) // Mb
      msgBox(LTrim(Str(nSize/10))+'Mb/s','Test')
   else
      ? 'Oops'
   endif
   ? 'PipeTest: ended'
   return

Function Thread2( oPipe )
   local nHnd := FCreate('test_output.txt')

   if oPipe:pipeIn() > 0 .and. oPipe:pipeOut() > 0 .and. nHnd > 0
      cBuffer := oPipe:recv()
      while !(cBuffer == 'CLOSE_PIPE')
         Fwrite(nHnd, cBuffer)
         cBuffer := oPipe:recv()
      enddo
      oPipe:closeOut()
      ? 'PipeTestClient: Ended'
   else
      ? 'Error reading pipe'
   endif

   return 0





